#!/usr/bin/python
import unittest
import sys
from ps6b import *

# Checks correctness of algorithm
def isCorrect(num):
    urlsA, urlsB = read_input("ps6b_sample_data/input" + str(num) + ".txt")
    correct_answer = read_integer("ps6b_sample_data/output" + str(num) + ".txt")
    answer = longest_common_subsequence(urlsA, urlsB)
    return (answer == correct_answer)

# Testing framework for part B of problem set 6
class TestPS6B(unittest.TestCase):
    def setUp(self):
        pass

    def test1(self):
        doesPass = isCorrect(1)
        self.assertTrue(doesPass)

    def test2(self):
        doesPass = isCorrect(2)
        self.assertTrue(doesPass)

    def test3(self):
        doesPass = isCorrect(3)
        self.assertTrue(doesPass)

    def test4(self):
        doesPass = isCorrect(4)
        self.assertTrue(doesPass)

    def test5(self):
        doesPass = isCorrect(5)
        self.assertTrue(doesPass)


def read_input(filename):
    """
    Reads a file and returns two lists of URLs contained in that file.
    File format is:
    Line 0: The number k of URLs we receive from each of the search engines.
    Lines 1 to k: The list of k URLs received from A.
    Lines k+1 to 2k: The list of k URLs received from B.
    """
    try:
        fp = open(filename)
        content = fp.read()
    except IOError:
        print "Error opening or reading file: ", filename
        sys.exit()
    lines = content.split('\n')
    # Read k from the first line
    try:
        k = int(lines[0])
    except ValueError:
        print "Error: the input file doesn't consist of a single integer"
        sys.exit()
    return (lines[1:k+1], lines[k+1:2*k+1])


def read_integer(filename):
    """
    Reads and returns an integer from the file filename.
    """
    try:
        fp = open(filename)
        content = fp.read()
    except IOError:
        print "Error opening or reading file: ", filename
        sys.exit()
    # Convert contents into an integer
    try:
        number = int(content)
    except ValueError:
        print "Error: the input file doesn't consist of a single integer"
        sys.exit()
    return number


if __name__ == '__main__':
    suite = unittest.TestLoader().loadTestsFromTestCase(TestPS6B)
    unittest.TextTestRunner(verbosity=2).run(suite)
